
$(document).ready(function(){
	$("#actions button").attr('disabled',true);
	// websocketConnect();
});

			
function websocketConnect(){
	devicewise.connect('ws://'+$("#url").val()+':9980', 
		function(evt){
			$("#websocketState").html("Connected");
			$('#actions #login').removeAttr('disabled');
			//login()
			},
		function(evt){
			$("#websocketState").html("Disconnected");
			$("#actions button").attr('disabled',true);
			},
		function(evt){
			$("#websocketState").html("Disconnected");
			$("#actions button").attr('disabled',true);
			}
	);
};

function login(){
	devicewise.login("websocketapi","wV7/btowyFzwgPlwhgPDV5jR1AaBVeoty9uQ3AjESxg=",
		function(){
			$("#loginState").html("Logged in");
			$('#actions button').removeAttr('disabled');
			$("#login").attr('disabled',true);
		},
		function(){
			$("#loginState").html("Login failed");
		}
	);
};

function logout(){
	devicewise.logout();
	$("#loginState").html("Logged out");
	$('#actions button').attr('disabled',true);
}

function readVar(){
	console.log("readVar");
	devicewise.read(
		$("#readDevice").val(),
		$("#readVariable").val(),
		$("#readType").val(),
		$("#readCount").val(),
		$("#readLength").val(),
		function(data){
			if(data.constructor === Array){$("#readResponse").html(data.toString());}
			else{$("#readResponse").html(data)}
		},
		function(error){$("#readResponse").html("Error: "+error);}
	);
}

function writeVar(){
	if($("#writeData").val().indexOf(",")>0){
		var data = $("#writeData").val().split(',');
	}else{
		var data = $("#writeData").val();
	}
	devicewise.write(
		$("#writeDevice").val(),
		$("#writeVariable").val(),
		$("#writeType").val(),
		$("#writeCount").val(),
		$("#writeLength").val(),
		data,
		function(){$("#writeResponse").html("Success");},
		function(error){$("#writeResponse").html("Error: "+error);}
	);
}

var subscriptions = [];
var counter = 0;
function subscribeVar(){
	devicewise.subscribe(
		$("#subscribeDevice").val(),
		$("#subscribeVariable").val(),
		$("#subscribeRate").val(),
		$("#subscribeType").val(),
		$("#subscribeCount").val(),
		$("#subscribeLength").val(),
		function(id, variable){
			$("#subscribeResponse").html("Subscribed to: "+variable);
			subscriptions.push(id);
		},
		function(error){
			$("#subscribeResponse").html("Error: "+error);
		},
		function(varObj){
			$("#subscriptions").prepend("<span>"+varObj.variable+": "+varObj.value+"<br></span>");
			if(counter<10){
				counter++;
			}else{
				$(".subscriptionRow span").last().remove();
			}
		}
	);
}

function unsubscribeAll(){
	for(var i=0; i<subscriptions.length; i++){
		devicewise.unsubscribe(subscriptions[i],function(){
			$("#subscribeResponse").html("Unsubscribed to all subscriptions.");
		},function(){
			$("#subscribeResponse").html("Unsubscribed to all subscriptions failed.");
		});
	}
}

function deviceList(){
	devicewise.deviceList(
		function(data){$("#deviceList").html(JSON.stringify(data));console.log(data)},
		function(){}
	);
}

function triggerList(){
	devicewise.triggerList(
		$("#triggerListProject").val(),
		function(data){
			$("#triggerList").html(JSON.stringify(data));
			console.log(data)
		},
		function(){}
	);
}

function projectList(){
	devicewise.projectList(
		function(data){
			$("#projectList").html(JSON.stringify(data));
			console.log(data)
		},
		function(){}
	);
}

function triggerStart(){
	devicewise.triggerStart($("#triggerStartProject").val(),$("#triggerStartTrigger").val(),
	function(){$("#triggerStartResponse").html("Success")},
	function(error){$("#triggerStartResponse").html(error)});
}

function triggerFire(){
	devicewise.triggerFire($("#triggerFireProject").val(),$("#triggerFireTrigger").val(),
	function(){$("#triggerFireResponse").html("Success")},
	function(error){$("#triggerFireResponse").html(error)});
}

function triggerStop(){
	devicewise.triggerStop($("#triggerStopProject").val(),$("#triggerStopTrigger").val(),
	function(){$("#triggerStopResponse").html("Success")},
	function(error){$("#triggerStopResponse").html(error)});
}

function projectStart(){
	devicewise.projectStart($("#projectStartProject").val(),
	function(){$("#projectStartResponse").html("Success")},
	function(error){$("#projectStartResponse").html(error)});
}

function projectStop(){
	devicewise.projectStop($("#projectStartProject").val(),
	function(){$("#projectStopResponse").html("Success")},
	function(error){$("#projectStopResponse").html(error)});
}

function deviceInfo(){
	devicewise.deviceInfo($("#deviceInfoDevice").val(),
	function(data){$("#deviceInfoResponse").text(data)}, 
	function(error){$("#deviceInfoResponse").text("Error: "+error)});
}

function deviceStart(){
	devicewise.deviceStart($("#deviceStartDevice").val(),
	function(){$("#deviceStartResponse").html("Success")},
	function(error){$("#deviceStartResponse").html(error)});
}

function deviceStop(){
	devicewise.deviceStop($("#deviceStopDevice").val(),
	function(){$("#deviceStopResponse").html("Success")},
	function(error){$("#deviceStopResponse").html(error)});
}

var messages=0;
function channelSubscribe(){
	devicewise.channelSubscribe($("#channelSubscribeChannel").val(),
	function(){$("#channelSubscribeResponse").text("Success")},
	function(data){$("#channelSubscribeResponse").text("Error: "+data)},
	function(data){
		if(messages>5){
			$("#channelSubscribePost span").last().remove();
		}else{
			messages++;
		}
		$("#channelSubscribePost").prepend("<span>"+data+"</br></span>");
		console.log(data);
	});
}

function networkPing(){
	devicewise.networkPing($("#networkPingIP").val(),parseInt($("#networkPingNumPings").val()),
	function(data){
		$("#networkPingResponse").text(data);
	},
	function(){
		
	});
}

function referenceList(){
	devicewise.referenceList($("#referenceListSourceType").val(),$("#referenceListSource").val(),$("#referenceListOptions").val(),
	function(data){$("#referenceListResponse").text(data)},
	function(error){$("#referenceListResponse").text("Error: "+error)}
	);
}

function SQLiteExec(){
	console.log($("#SQLiteExecQuery").val());
	devicewise.SQLiteExec($("#SQLiteExecQuery").val(),
		function(data){
			$("#SQLiteExecResponse").text(data);
			console.log(data)
		},
		function(){}
	);
}